<%@ CodePage=65001 Language="VBScript"%>
<%
  response.expires = -1
  ' Update the constants file
  if request("action") = "update" then

  dim quote, CRLF
  Quote = chr(34)
  CRLF  = chr(13) & chr(10)

    sQuote = """"
    ' Eliminate any trailing slahes from the forum root
    sBBSForumRoot = trim(request("sBBSForumRoot"))
    if right(sBBSForumRoot, 1) = "/" or right(sBBSForumRoot, 1) = "\" then
      sBBSForumRoot = left(sBBSForumRoot, len(sBBSForumRoot)-1)
    end if
    sBBSForumRoot = trim(sBBSForumRoot)

    ' Trim padding from the connection string
    ' Main
    sBBSForumRoot                  = sBBSForumRoot
    sBBSPreferredDomain            = trim(request("sBBSPreferredDomain"))

    'Database
    sBBSDatabaseType                = left(trim(request("sBBSDatabaseType")),20) ' MSAccess, MSSQL, Custom
    sMSAccessFileName               = replace(left(trim(request("sMSAccessFileName")),200), "\", "/")
    sMSSQLServerAddress             = left(trim(request("sMSSQLServerAddress")),200)
    sMSSQLUsername                  = left(trim(request("sMSSQLUsername")),200)
    sMSSQLPassword                  = left(trim(request("sMSSQLPassword")),200)
    sMSSQLInitialCatalog            = left(trim(request("sMSSQLInitialCatalog")),200)
    sMYSQLServerAddress             = left(trim(request("sMYSQLServerAddress")),200)
    sMYSQLServerPort                = left(trim(request("sMYSQLServerPort")),200)
    sMYSQLUsername                  = left(trim(request("sMYSQLUsername")),200)
    sMYSQLPassword                  = left(trim(request("sMYSQLPassword")),200)
    sMYSQLDatabase                  = left(trim(request("sMYSQLDatabase")),200)
    sqlformat                       = request.form("sqlformat")
    if ucase(sBBSDatabaseType) = "MSACCESS" then sqlformat = "iso"

    sCustomConnString               = left(trim(request("sCustomConnString")),200)
    sCustomDateDelimiter            = left(trim(request("sCustomDateDelimiter")),200)
    sBBSCookieRoot                  = left(trim(request("sBBSCookieRoot")),200)
    sMSAccessFilePath               = left(trim(request("sMSAccessFilePath")), 200)

    if left(sMSAccessFileName,1) <> "/" and left(sMSAccessFileName,1) <> "\" then sMSAccessFileName = "/" & sMSAccessFileName

    if sBBSDatabaseType = "MSAccess" then
       if request.form("userelative") = 1 then
         sConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & server.mappath("/") & sMSAccessFileName & ";"
         sMSAccessFilePath = server.mappath("/") & sMSAccessFileName
       else
         sConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & sMSAccessFilePath & ";"
       end if
       sConnString = replace(sConnString, "/", "\")
       sDateDelimiter = "#"

    elseif ucase(sBBSDatabaseType) = "MSSQL" then
       sConnString = "Provider=SQLOLEDB; Data Source=" & sMSSQLServerAddress & _
                     "; User ID=" & sMSSQLUsername & "; Password=" & sMSSQLPassword & _
                     "; Initial Catalog=" & sMSSQLInitialCatalog & ";"
       sDateDelimiter = "'"

    elseif ucase(sBBSDatabaseType) = "MYSQL" then
       sConnString = "Driver={MySQL ODBC 3.51 Driver}; Server=" & sMYSQLServerAddress & _
                     "; Option=16834; Port=" & sMYSQLServerPort & _
                     "; Database=" & sMYSQLDatabase & _
                     "; Uid=" & sMYSQLUsername & "; Pwd=" & sMYSQLPassword & ";"
       sDateDelimiter = "'"

    elseif sBBSDatabaseType = "Custom" then
       sConnString    = sCustomConnString
       sDateDelimiter = sCustomDateDelimiter

    end if



  sWriteString = sWriteString & ("%" & ">") & CRLF

  response.buffer=true
  response.clear
  response.contenttype = "text/plain"
  Response.CacheControl = "no-cache"

  Response.AddHeader "content-disposition","attachment; filename=constants.asp"
  response.write "<" & "%"& CRLF
  response.write "'Please copy this and update your /database/constants.asp file" & CRLF
  response.write "' ---" & CRLF
  ' First add the constants
  response.write "dim bEmergencyMode, sBBSSQLFormat, sBBSForumRoot, sBBSCookieRoot, sBBSPreferredDomain, sBBSDatabaseType, sMSAccessFilePath, sConnString, sDateDelimiter, bNoSetup" & CRLF
  response.write CRLF
  response.write "' ************************************************************************" & CRLF
  response.write "' *** EITHER REMOVE THIS LINE OR SET IT TO ZERO AFTER THE BBS IS SETUP ***" & CRLF
  response.write "' ************************************************************************" & CRLF
  response.write "bEmergencyMode = 1" & CRLF & CRLF & CRLF

  ' Main
  response.write "sBBSForumRoot         =""" & (sBBSForumRoot) & """" & CRLF
  response.write "sBBSPreferredDomain   = Request.ServerVariables(""SERVER_NAME"")" & CRLF

  ' Database

  response.write "sBBSSQLFormat         =""" & sqlformat & """" & CRLF
  response.write "sBBSDatabaseType      =""" & sBBSDatabaseType & """" & CRLF
  response.write "sMSAccessFilePath     =""" & sMSAccessFilePath & """" & CRLF
  response.write "sConnString           =""" & replace(sConnString, sQuote, sQuote & sQuote) & """" & CRLF
  response.write "sDateDelimiter        =""" & sDateDelimiter & """" & CRLF
  response.write "sBBSCookieRoot        =""" & sBBSCookieRoot & """" & CRLF

  response.write "%" & ">"
  response.end
  end if


' Setup default values

 sBBSForumRoot = left(request.servervariables("SCRIPT_NAME"), len(request.servervariables("SCRIPT_NAME")) - 20)
 sBBSPreferredDomain= request.servervariables("HTTP_HOST")
 sBBSCookieRoot = "/"
 sMSAccessFileName = "/fpdb/megabbs.mdb"
 sMSSQLServerAddress = sBBSPreferredDomain
 sMSSQLUsername = "username"
 sMSSQLPassword = "password"
 sMSSQLInitialCatalog = "databasename"
 sMSAccessFilePath = server.mappath("/") & "\megabbs.mdb"
 sMYSQLServerAddress = sBBSPreferredDomain
 sMYSQLServerPort = "3306"
 sMYSQLUserName = "username"
 sMYSQLPassword = "password"
 sMYSQLDatabase = "databasename"

%>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>
<meta http-equiv="content-type" content="text-html; charset=utf-8">
<title>BBS Setup</title>
<link rel='stylesheet' href='../templates/original/template.css' type='text/css'>
</head><body>
<style type="text/css">
.messagecellheader{background-image:url('../templates/original/images/common/messagecellheader-background.gif');background-repeat:repeat-x; background-position:top; height:24;}
.messagecellfooter{background-image:url('../templates/original/images/common/messagecellfooter-background.gif'); background-position: bottom; background-repeat:repeat-x; height:24;}
.messagecellheader2{background-image:url('../templates/original/images/common/messagecellheader2-background.gif'); background-position: top; background-repeat:repeat-x; height:20;}
.bbstextbox{background-position: left top; background-image:url('../templates/original/images/common/cell-background.gif'); background-repeat:no-repeat; background-attachment:fixed;}
.bbseditbox{background-position: left top; background-image:url('../templates/original/images/common/cell-background.gif'); background-repeat:no-repeat; background-attachment:fixed;}
.navbar{ background-image:url('../templates/original/images/common/navbar-background.gif'); background-repeat:repeat-x};
</style>
<br/>
<script type="text/javascript">
function validateform()
{
 var optAccess;
 var optSQL;
 optAccess = document.getElementById('access');
 optSQL    = document.getElementById('mssql');
 optmySQL    = document.getElementById('mysql');
if (optAccess.checked==false && optSQL.checked==false && optmySQL.checked==false)
 {
   window.alert('Please choose either MS-Access, MS-SQL server or mySQL server');
   return false;
 }
 else
 {
   return true;
 }
}

</script>
<form id='constantsform' onsubmit='return(validateform());' method="POST" action="bbs-setup.asp">
<input type="hidden" name="action" value="update">
  <table align="center" class="bbstable" cellspacing="1" width="50%" >
    <tr><td class="messagecellheader">Forum Setup Version 2.2</td></tr>
    <tr><td class="messagecellheader2">General configuration variables</td></tr>
    <tr><td class="messagecellbody">This page automates the construction of your constants.asp file.  The constants.asp stores fundamental configuration options about your system.  You will only need to perform this step once.<br/>
      <br/>
      <b>Root path to the BBS:</b><br/>
      <input type="text" class="bbstextbox" name="sBBSForumRoot" size="75" maxlength="100"  value="<%=sBBSForumRoot%>"> ex. '/forum'<br/>
      <br/>
    </td></tr>
    <tr><td class="messagecellspacer"></td></tr>
    <tr><td class="messagecellbody">
      <b>Preferred domain:</b><br/>
      <input type="text" class="bbstextbox" name="sBBSPreferredDomain" size="75" maxlength="100"  value="<%=sBBSPreferredDomain%>"> ex. 'www.yourdomain.com'<br/>
      <br/>
      Give the preferred address of the forum, if your website has more than one correct name. <br/>
      This will help to ensure the proper coloring of visited links, and enable proper cookie functionality.<br/>
      <br/>
      <b>Note:</b><br/>
      Using addresses like `localhost' or `machine-name' may not work correctly.<br/>
      If in doubt, use the default value supplied, or your IP address.<br/>
      <br/>
    </td></tr>

    <tr><td class="messagecellheader2">Database connection variables</td></tr>
    <tr>
      <td class="messagecellbody" >
      <input type="radio" class="bbsradiobox" id='access' name="sBBSDatabaseType" value="MSAccess">Use a MS Access database
        <blockquote>
          <input type='radio' checked value='1' name='userelative'> Use a relative path to your database (/fpdb/megabbs.mdb)<br/>
          <input type="text" class="bbstextbox" name="sMSAccessFileName" size="75" maxlength="200" value="<%=sMSAccessFileName%>"><br/>
          <br/>
          <input type='radio' value='0' name='userelative'> Use the full path to your database (c:\inetpub\wwwroot\database\megabbs.mdb)<br/>
          <input type="text" class="bbstextbox" name="sMSAccessFilePath" size="75" maxlength="200" value="<%=sMSAccessFilePath%>"><br/>
          <br/>
          Enter a path, relative or absolute, to your access database.&nbsp; You must make sure the IUSR account has read and write access to this file,
          however it should be placed where it cannot be downloaded.
        </blockquote>
        <p><input id='mssql' type="radio" class="bbsradiobox" name="sBBSDatabaseType" value="MSSQL">Use a MS SQL server database</p>
        <blockquote>
          <p><input type="text" class="bbstextbox" name="sMSSQLServerAddress" size="75" maxlength="200" value="<%=sMSSQLServerAddress%>"><br/>
          Enter the IP to the SQL server.</p>
          <p><input type="text" class="bbstextbox" name="sMSSQLUsername" size="75" maxlength="200" value="<%=sMSSQLUsername%>"><br/>
          Enter a username.</p>
          <p><input type="text" class="bbstextbox" name="sMSSQLPassword" size="75" maxlength="200" value="<%=sMSSQLPassword%>"><br/>
          Enter the password.</p>
          <p><input type="text" class="bbstextbox" name="sMSSQLInitialCatalog" size="75"  maxlength="200" value="<%=sMSSQLInitialCatalog%>"><br/>
          Enter the name of the database.</p>
        </blockquote>
        <p><input id='mysql' type="radio" class="bbsradiobox" name="sBBSDatabaseType" value="MYSQL">Use a mySQL server database</p>
        <blockquote>
          <p><input type="text" class="bbstextbox" name="sMYSQLServerAddress" size="75" maxlength="200" value="<%=sMYSQLServerAddress%>"><br/>
          Enter the IP to the mySQL server.</p>
          <p><input type="text" class="bbstextbox" name="sMYSQLServerPort" size="75" maxlength="200" value="<%=sMYSQLServerPort%>"><br/>
          Enter the port to the mySQL server (default 3306).</p>
          <p><input type="text" class="bbstextbox" name="sMYSQLUsername" size="75" maxlength="200" value="<%=sMYSQLUsername%>"><br/>
          Enter a username.</p>
          <p><input type="text" class="bbstextbox" name="sMYSQLPassword" size="75" maxlength="200" value="<%=sMYSQLPassword%>"><br/>
          Enter the password.</p>
          <p><input type="text" class="bbstextbox" name="sMYSQLDatabase" size="75"  maxlength="200" value="<%=sMYSQLDatabase%>"><br/>
          Enter the name of the database.</p>
        </blockquote>

<!--
        <select name='sqlformat'><option value='iso'>yyyy-mm-dd (ISO) -- DO NOT CHANGE</option><option value='us'>mm/dd/yyyy (US)</option><option value='eur'>dd/mm/yyyy (eur)</option></select><br/>
        <font color='red'>SQL Date format (Access and MSSQL should use ISO format, do not change unless you understand the implications)</font><br/>
        You can change the way dates are <b>displayed</b> later in the configuration process -->
    </td></tr>
    <tr><td class='messagecellbody'>When you click the generate button, you will be prompted to save a file called constants.asp.
    Save it to your local system.  Upload the new constants.asp over the old one in /forum/database/constants.asp .
    Assuming no other problems, your setup of the BBS is now complete, and you can proceed to testing the connection and configuring the system.<br/>
    <br/>
    After updating your constants.asp file, use the `Test connection' button to verify that the settings were correct. If there were any problems, return to this screen and try to correct any errors. If the database was setup properly, you may delete this file and remove it from your system.<br/>
    <br/>
    </td></tr>
    <tr><td class="messagecellfooter" align='center'>
      <input onclick='return (validateform());' type="submit" value="Generate new constants file" class='bbsbutton'>&nbsp;&nbsp;&nbsp;
      <input type='button' class='bbsbutton' value='Test database connection' onclick='document.location="bbs-testsetup.asp"'></td></tr>
    </table>

</form>
<br/>
</body>
</html>