<%@ CodePage=65001 Language="VBScript"%>
<% Option Explicit %>
<!-- #include file="../includes/include.asp"-->
<% sBBSLangPage = "admin"
   BBS.SetupBBS
   BBS.SetScheme(0)

   dim iUserLevel, iModule, SQL, sFormFragment, iID, iIDType, iTarget, sDefaultType

   iUserLevel = BBS.ValidateNumeric(request.querystring("userlevel"))
   iModule    = BBS.ValidateNumeric(request.querystring("module"))
   iTarget    = BBS.ValidateNumeric(request.querystring("target"))
   if iUserLevel = 0 then iUserLevel = USERLEVEL_GlobalAdministrator
   if iModule    = 0 then iModule    = 0
   if iTarget    = 0 then iTarget    = -1
   sDefaultType = "user"

   ' Delete any bogus accounts

   ' No "global" moderators on modules
   SQL = "delete from userlevelmembers where userlevel<=" & USERLEVEL_Moderator & " and targetid=-1 and (moduleid=" & MODULE_Forums & " or moduleid=" & MODULE_Calendars & " or moduleid=" & MODULE_Albums & " or moduleid=" & MODULE_Quotes & ")"
   dbConnection.execute SQL

   ' No BBS module accounts below support administrators
   SQL = "delete from userlevelmembers where userlevel<" & USERLEVEL_SupportAdministrator & " and moduleid in (" & MODULE_BBS & ")"
   dbConnection.execute SQL

   ' Module administrators must have a target = -1
   SQL = "delete from userlevelmembers where userlevel=" & USERLEVEL_ModuleAdministrator & " and targetid<>-1 and (moduleid=" & MODULE_Forums & " or moduleid=" & MODULE_Calendars & " or moduleid=" & MODULE_Albums & " or moduleid=" & MODULE_Quotes & ")"
   dbConnection.execute SQL

   ' Check for any bogus targets before processing this page
   if iUserLevel <= USERLevel_Moderator and iTarget=-1 and (iModule=MODULE_Forums or iModule=MODULE_Calendars or iModule=MODULE_Albums or iModule=MODULE_Quotes) then
     response.redirect "index.asp"
   elseif iModule=MODULE_BBS and (iUserLevel < USERLEVEL_SupportAdministrator or iTarget <> -1) then
     response.redirect "index.asp"
   elseif iUserLevel = USERLEVEL_ModuleAdministrator  and iTarget<>-1 and (iModule=MODULE_Forums or iModule=MODULE_Calendars or iModule=MODULE_Albums or iModule=MODULE_Quotes) then
     response.redirect "index.asp"
   elseif iModule < MODULE_BBS or iModule > MODULE_Quotes then
     response.redirect "index.asp"
   end if

   ' If emergency mode is enabled, then bypass security checks
   if not(bEmergencyMode = 1) then
    if iUserLevel = USERLEVEL_GlobalAdministrator then
     if not(BBS.HasPermission(PERM_admineditglobaladministrators,-1)) then response.redirect "../logon.asp?error=admin"
     dictEnvironment("V-USERLEVEL") = dictLanguage.item("ADMIN-1")
    elseif iUserLevel = USERLEVEL_SupportAdministrator then
     if not(BBS.HasPermission(PERM_admineditsupportadministrators,-1)) then response.redirect "../logon.asp?error=admin"
     dictEnvironment("V-USERLEVEL") = dictLanguage.item("ADMIN-2")
    elseif iUserLevel = USERLEVEL_ModuleAdministrator then
     if not(BBS.HasPermission(PERM_admineditmoduleadministrators,iModule)) then response.redirect "../logon.asp?error=admin"
     dictEnvironment("V-USERLEVEL") = dictLanguage.item("ADMIN-3")
    elseif (iUserLevel = USERLEVEL_Moderator) then
     if iModule = MODULE_FORUMS THEN
       if not(BBS.HasPermission(PERM_modeditmoderators, iModule)) then response.redirect "../logon.asp?error=admin"
     elseif iModule = MODULE_CALENDARS then
       if not(BBS.HasPermission(PERM_modeditmoderators, iModule)) then response.redirect "../logon.asp?error=admin"
     else
       if not(BBS.HasPermission(PERM_modeditmoderators, iModule)) then response.redirect "../logon.asp?error=admin"
     end if
     dictEnvironment("V-USERLEVEL") = dictLanguage.item("ADMIN-4")
    elseif (iUserLevel = USERLEVEL_SpecialAccess) then
     if not(BBS.HasPermission(PERM_modeditspecialaccess, iTarget)) then response.redirect "../logon.asp?error=admin"
     dictEnvironment("V-USERLEVEL") = dictLanguage.item("ADMIN-5")
    end if
   end if

   if request.form("action") = "add" then
     if request.form("type") = "user" then
       iIDType = USERLEVEL_MEMBER
       iID = BBS.GetMemberID(request.form("name"))
     else
       iIDType = USERLEVEL_GROUP
       iID = BBS.GetGroupID(request.form("name"))
       sDefaultType = "group"
     end if

     if iID > 0 then
       ' Check if this user/group already exists in the list
       SQL = "select id from userlevelmembers where moduleid=" & BBS.ValidateNumeric(iModule) & " and userlevel=" & BBS.ValidateNumeric(iUserLevel)
       SQL = SQL & " and idtype=" & BBS.ValidateNumeric(iIDType) & " and ID=" & BBS.ValidateNumeric(iID) & " and targetid=" & BBS.ValidateNumeric(iTarget) & ";"
       rsMaster.open SQL
       if rsMaster.EOF then
         sql = "insert into userlevelmembers (moduleid, userlevel, idtype, id, targetid) VALUES("
         SQL = SQL & BBS.ValidateNumeric(iModule) & ", " & BBS.ValidateNumeric(iUserLevel) & ", " & BBS.ValidateNumeric(iIDType) & ", " & BBS.ValidateNumeric(iID) & ", " & BBS.ValidateNumeric(iTarget) & ");"
         dbConnection.Execute SQL
         BBS.CacheDeleteAll
       else
         dictEnvironment.add "V-ERROR", dictLanguage.item("ADMIN-54")
       end if
       rsMaster.Close
     else
       dictEnvironment.add "V-ERROR", dictLanguage.item("ADMIN-53")
     end if
     BBS.CacheDeleteType("LM")
   end if

   ' Delete users from this level
   if request.form("action") = "remove" then

     for each iID in request.form("deletegroup")
       SQL = "delete from userlevelmembers where moduleid=" & BBS.ValidateNumeric(iModule) & " and userlevel=" & BBS.ValidateNumeric(iUserLevel)
       SQL = SQL & " and idtype=" & BBS.ValidateNumeric(USERLEVEL_GROUP) & " and targetid=" & BBS.ValidateNumeric(iTarget) & " and ID=" & BBS.ValidateNumeric(iID)
       dbConnection.Execute SQL
     next

     for each iID in request.form("deletemember")
       SQL = "delete from userlevelmembers where moduleid=" & BBS.ValidateNumeric(iModule) & " and userlevel=" & BBS.ValidateNumeric(iUserLevel)
       SQL = SQL & " and idtype=" & BBS.ValidateNumeric(USERLEVEL_MEMBER) & " and targetid=" & BBS.ValidateNumeric(iTarget) & " and ID=" & BBS.ValidateNumeric(iID)
       dbConnection.Execute SQL
     next
     BBS.CacheDeleteAll
   end if

   dictEnvironment("V-TITLE") = dictLanguage.item("ADMIN-6") & " " & dictEnvironment("V-USERLEVEL")
   dictEnvironment("U-FORMACTION") = "userlevelmembers-edit.asp?userlevel=" & iUserLevel & "&module=" & iModule & "&target=" & iTarget
   dictEnvironment("V-FORMINPUTADD") = "<input type='hidden' name='action' value='add'>"
   dictEnvironment("V-FORMINPUTREMOVE") = "<input type='hidden' name='action' value='remove'>"

   SQL = "select members.memberid, members.username from userlevelmembers, members where userlevelmembers.moduleid=" & iModule & " and userlevelmembers.idtype=" & USERLEVEL_MEMBER & " and userlevelmembers.userlevel=" & iUserLevel & " and userlevelmembers.targetid=" & BBS.ValidateNumeric(iTarget) & " and userlevelmembers.id = members.memberid order by members.username ASC;"
   rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
   do until rsMaster.EOF
     sFormFragment = sFormFragment & "<input type='checkbox' name='deletemember' value='" & rsMaster.fields(0).value & "'> " & BBS.ValidateField(rsMaster.fields(1).value) & "<br/>"
     rsMaster.MoveNext
   loop
   rsMaster.Close

   SQL = "select groups.groupid, groups.groupname from userlevelmembers, groups where userlevelmembers.moduleid=" & iModule & " and userlevelmembers.idtype=" & USERLEVEL_GROUP & " and userlevelmembers.userlevel=" & iUserLevel & " and userlevelmembers.targetid=" & BBS.ValidateNumeric(iTarget) & " and userlevelmembers.id = groups.groupid order by groups.groupname ASC;"
   rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
   do until rsMaster.EOF
     sFormFragment = sFormFragment & "<input type='checkbox' name='deletegroup' value='" & rsMaster.fields(0).value & "'> " & dictLanguage("ADMIN-13") & " " & BBS.CreateGroupnameLink(rsMaster.fields(0).value) & BBS.ValidateField(rsMaster.fields(1).value) & "</a><br/>"
     rsMaster.MoveNext
   loop
   rsMaster.Close
   dictEnvironment("V-DELETELIST") = sFormFragment

   ' Override for admin-include-header, otherwise it will redirect moderators here legitimately back to category-view.asp
   sBBSLangPage = "bCanViewAnything=True"


%>

<!-- #include file="admin-include-header.asp" -->

<script language="JavaScript">
function opensearch(sID)
{
  var sType;
  targetid = document.getElementById(sID);
  if (document.getElementById("usersearch").checked == true)
    {sType = "user"}
  else
    {sType = "group"}
  var newwindow = window.open("<%=sBBSForumRoot%>/search/user-search.asp?type="+sType, "search","toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=400,height=300");newwindow.focus();newwindow.moveTo(50,50);
}

function setvalue(sValue)
{
  targetid.value = sValue;
}
</script>

<div class="error" align="center"><%=dictEnvironment("V-ERROR")%></div><br/><br/>
<table align="center" width="85%" class="bbstable">
<tr><td colspan="2" class="messagecellheader" align="center"><%=dictEnvironment("V-TITLE")%></td></tr>
<tr><td align="center" valign="top" width="50%" class="messagecellbody">

  <br/><br/>
  <form method="post" action="<%=dictEnvironment("U-FORMACTION")%>">
  <%=dictEnvironment("V-FORMINPUTADD")%>
  <table width="85%" cellspacing="<%=dictTemplate("CELLSPACING")%>" class="bbstable">
  <tr><td class="messagecellheader" colspan="2"><%=dictLanguage("ADMIN-7")%></td></tr>
  <tr><td class="messagecellbody"><%=dictLanguage("ADMIN-10") & " "%></td>
  <td class="messagecellbody">
    <input type="radio" name="type" id='usersearch' value="user" <%=BBS.IsChecked(sDefaultType = "user")%>> <%=dictLanguage("ADMIN-11")%><br/>
    <input type="radio" name="type" id='groupsearch' value="group" <%=BBS.IsChecked(sDefaultType = "group")%>> <%=dictLanguage("ADMIN-12")%><br/>
  </td></tr>
  <tr><td class="messagecellbody2"><%=dictLanguage("ADMIN-9") & " "%></td>
    <td class="messagecellbody2" nowrap><input type="text" class="bbstextbox" name="name" id='addname' maxlength="75" size="30">
      <input type='button' class='bbsbutton' value='...' onclick='opensearch("addname")'>
    </td></tr>
  <tr><td colspan="2" class="messagecellfooter" align="center"><input type="submit" class="bbsbutton" value="<%=dictLanguage("GLOBAL-SUBMIT")%>"></td></tr>
  </table>
  </form>
<br/><br/>
</td>
<td align="center" valign="top" width="50%" class="messagecellbody">
<br/><br/>

  <form method="post" action="<%=dictEnvironment("U-FORMACTION")%>">
  <%=dictEnvironment("V-FORMINPUTREMOVE")%>
  <table width="85%" cellspacing="<%=dictTemplate("CELLSPACING")%>" class="bbstable">
  <tr><td nowrap class="messagecellheader"><%=dictLanguage("ADMIN-8")%></td></tr>
  <tr><td nowrap class="messagecellbody">
  <%=dictEnvironment("V-DELETELIST")%>
  </td></tr>
  <tr><td class="messagecellfooter" align="center"><input type="submit" class="bbsbutton" value="<%=dictLanguage("GLOBAL-DELETE")%>"></td></tr>
  </table>
  </form>
<br/><br/>
</td>
</tr>
</table>
<br/>

<!-- #include file="admin-include-footer.asp" -->
