<%@ CodePage=65001 Language="VBScript"%>
<% Option Explicit %>
<!-- #include file="../includes/include.asp"-->
<!-- #include file="../includes/include-calendar.asp"-->
<%
   sBBSLangPage = "calendar"
   BBS.SetupBBS
   BBS.SetScheme(0)

   dictEnvironment.item("V-LOCATIONLINKS") = dictEnvironment.item("V-LOCATIONLINKS") & " -&gt; <a href='" & sBBSForumRoot & "/calendar/calendar-list.asp'>" & dictLanguage("GLOBAL-LOCATION6") & "</a> -&gt; " & dictLanguage("GLOBAL-LOCATION8")

   dim iCalendarID, iEventID, vCalendarInfo, vEventInfo, sAction, bError, sPostAction, iNewID, sOutput
   iCalendarID = request.querystring("calendarid")
   sAction     = request.querystring("action")
   iEventID    = request.querystring("eventid")
   vCalendarInfo = Calendar.GetCalendarInfo(iCalendarID)
   if vCalendarInfo(CI_CalendarID) = -1 then response.redirect "calendar-list.asp"

   ' Include the neccessary files for calendar
   dictEnvironment.item("C-EXTRAHEADTAG") = dictEnvironment.item("C-EXTRAHEADTAG") & "<style type='text/css'>@import url(" & sBBSTemplateRoot & "/calendar.css);</style>" & CRLF
   dictEnvironment.item("C-EXTRAHEADTAG") = dictEnvironment.item("C-EXTRAHEADTAG") & "<script type='text/javascript' src='../jscalendar/calendar.js'></script>" & CRLF
   dictEnvironment.item("C-EXTRAHEADTAG") = dictEnvironment.item("C-EXTRAHEADTAG") & "<script type='text/javascript' src='" & Language.GetCalendarLanguage() & "'></script>" & CRLF
   dictEnvironment.item("C-EXTRAHEADTAG") = dictEnvironment.item("C-EXTRAHEADTAG") & "<script type='text/javascript' src='../jscalendar/calendar-setup.js'></script>" & CRLF

   ' Configure basic permissions
   if BBS.HasPermission(PERM_calendaraddpublicevent, iCalendarID) then
     dictEnvironment("C-ADDPUBLIC") = "1"
   else
     dictEnvironment("C-ADDPUBLIC") = "0"
   end if

   if BBS.HasPermission(PERM_calendaraddprivateevent, iCalendarID) then
     dictEnvironment("C-ADDPRIVATE") = "1"
   else
     dictEnvironment("C-ADDPRIVATE") = "0"
   end if

   if BBS.HasPermission(PERM_addrecurring, iCalendarID) then
     dictEnvironment("C-ADDRECURRING") = "1"
   else
     dictEnvironment("C-ADDRECURRING") = "0"
   end if

   if not(dictConfiguration("bENABLECALENDAR") = "1") then response.redirect sBBSForumRoot & "/restricted-page.asp"
   if not(dictEnvironment("C-ADDPUBLIC") = "1" or dictEnvironment("C-ADDPRIVATE") = "1") then response.redirect sBBSForumRoot & "/restricted-page.asp"

   ' Possible actions : "add", "edit", "postadd", "postedit"
   if sAction = "add" then
     vEventInfo = Calendar.GetEventInfoStruct()
     vEventInfo(CEV_Month)      = BBS.ValidateNumeric(request.querystring("month"))
     vEventInfo(CEV_Year)       = BBS.ValidateNumeric(request.querystring("year"))
     vEventInfo(CEV_Day)        = BBS.ValidateNumeric(request.querystring("day"))
     vEventInfo(CEV_SingleDate) = BBS.FormatShortDate(dateserial(vEventInfo(CEV_Year), vEventInfo(CEV_Month), vEventInfo(CEV_Day)), dictConfiguration("sDATEFORMAT"))
     vEventInfo(CEV_Weekday)    = weekday(dateserial(vEventInfo(CEV_Year), vEventInfo(CEV_Month), vEventInfo(CEV_Day)))
     vEventInfo(CEV_AllDayEvent)= 1
     vEventInfo(CEV_Recurrence) = "none"
     sPostAction = "postadd"

   elseif sAction = "edit" then
     vEventInfo = Calendar.GetEventInfo(iEventID)
     vEventInfo(CEV_SingleDate) = BBS.GetShortDate(vEventInfo(CEV_SingleDate))
     vEventInfo(CEV_StartDateRange) = BBS.GetShortDate(vEventInfo(CEV_StartDateRange))
     vEventInfo(CEV_EndDateRange) = BBS.GetShortDate(vEventInfo(CEV_EndDateRange))
     sPostAction = "postedit"
     if vEventInfo(CEV_CalendarID) <> vCalendarInfo(CI_CalendarID) then response.redirect "calendars-list.asp"

   elseif sAction = "postadd" or sAction = "postedit" then

      bError = False

      ' Get fields and plug them into the structure
      if sAction = "postadd" then
        vEventInfo = Calendar.GetEventInfoStruct()
        sPostAction = "postadd"
      else
        vEventInfo = Calendar.GetEventInfo(iEventID)
        sPostAction = "postedit"
        if vEventInfo(CEV_CalendarID) <> vCalendarInfo(CI_CalendarID) then response.redirect "calendars-list.asp"
      end if

      vEventInfo(CEV_CalendarID) = vCalendarInfo(CI_CalendarID)
      if iBBSUserLevel > USERLEVEL_Guest then
        vEventInfo(CEV_Owner) = sBBSUsername
        vEventInfo(CEV_OwnerStatus) = 1
      else
        vEventInfo(CEV_Owner) = request.form("owner")
        vEventInfo(CEV_OwnerSTatus) = 0
      end if

      vEventInfo(CEV_ShortDesc)        = BBS.FilterPost(request.form("shortdesc"))
      if len(trim(vEventInfo(CEV_ShortDesc))) = 0 then vEventInfo(CEV_ShortDesc) = "---"
      vEventInfo(CEV_LongDesc)         = BBS.FilterPost(request.form("longdesc"))
      vEventInfo(CEV_Singledate)       = BBS.ParseDate(request.form("singledate"), dictConfiguration("sDATEFORMAT"))
      if not(isDate(vEventInfo(CEV_Singledate))) then vEventInfo(CEV_Singledate) = now
      vEventInfo(CEV_Weekday)          = BBS.ValidateNumeric(request.form("weekday"))
      if vEventInfo(CEV_Weekday) < 0 or vEventInfo(CEV_Weekday) > 7 then vEventInfo(CEV_Weekday) = weekday(vEventInfo(CEV_Singledate))
      vEventInfo(CEV_alldayevent)      = request.form("alldayevent")
      vEventInfo(CEV_timeofdayhour)    = request.form("timeofdayhour")
      vEventInfo(CEV_timeofdayminute)  = request.form("timeofdayminute")
      vEventInfo(CEV_timeofdaymeridian)= request.form("timeofdaymeridian")
      vEventInfo(CEV_AllowSignups)     = request.form("allowsignups")

      if dictEnvironment("C-ADDRECURRING") = "1" then
        vEventInfo(CEV_recurrence)    = request.form("recurrence")
        vEventInfo(CEV_hasdaterange)  = request.form("hasdaterange")
        vEventInfo(CEV_startdaterange)= BBS.ParseDate(request.form("startdaterange"), dictConfiguration("sDATEFORMAT"))
        vEventInfo(CEV_enddaterange)  = BBS.ParseDate(request.form("enddaterange"), dictConfiguration("sDATEFORMAT"))
        if not(IsDate(vEventInfo(CEV_StartDateRange))) then vEventInfo(CEV_StartDateRange) = vEventInfo(CEV_Singledate)
        if not(IsDate(vEventInfo(CEV_enddaterange))) then vEventInfo(CEV_enddaterange) = vEventInfo(CEV_Singledate)
      else
        vEventInfo(CEV_recurrence)    = "none"
        vEventiNfo(CEV_HasDateRange)  = 0
        vEventInfo(CEV_startdaterange)= now
        vEventInfo(CEV_enddaterange)  = now
      end if

      if vEventInfo(CEV_recurrence) = "monthly" then
        vEventINfo(CEV_Day)   = BBS.ValidateNumeric(request.form("monthlyday"))

        ' Sanity checking on date entry
        if vEventInfo(CEV_Day) <= 0 or vEventInfo(CEV_Day) > 31 then vEventInfo(CEV_Day) = day(now)
      elseif vEventInfo(CEV_recurrence) = "yearly" then
        vEventINfo(CEV_Day)   = BBS.ValidateNumeric(request.form("yearlyday"))
        vEventINfo(CEV_Month) = BBS.ValidateNumeric(request.form("yearlymonth"))

        ' Sanity checking on date entry
        if vEventInfo(CEV_Month)  <= 0 or vEventInfo(CEV_Month) > 12 then vEventInfo(CEV_Month) = month(now)

        ' Is the day-of-month less than 1
        if vEventInfo(CEV_Day) <= 0 then
          vEventInfo(CEV_Day) = 1
        ' Is it greater than the maximum day of this month
        elseif vEventInfo(CEV_Day) > day(dateserial(year(now), vEventInfo(CEV_Month)+1, 0)) then
          vEventInfo(CEV_Day) = day(dateserial(year(now), vEventInfo(CEV_Month)+1, 0))
        end if

      elseif vEventInfo(CEV_recurrence) = "none" and isDate(vEventInfo(CEV_Singledate)) then
        vEventInfo(CEV_Year)            = year(vEventInfo(CEV_Singledate))
        vEventInfo(CEV_Month)           = month(vEventInfo(CEV_Singledate))
        vEventInfo(CEV_Day)             = day(vEventInfo(CEV_Singledate))
        vEventInfo(CEV_HasDateRange)    = 0
        vEventInfo(CEV_startdaterange)  = vEventInfo(CEV_SingleDate)
        vEventInfo(CEV_enddaterange)    = vEventInfo(CEV_SingleDate)

      end if

      if dictEnvironment("C-ADDPUBLIC") = 0 then
        vEventinfo(CEV_Private) = 1
      else
        vEventInfo(CEV_Private) = request.form("private")
      end if

      if vEventInfo(CEV_Timeofdayhour) < 0 or vEventInfo(CEV_Timeofdayhour) > 23 then vEventInfo(CEV_Timeofdayhour) = 0
      if vEventInfo(CEV_Timeofdayminute) < 0 or vEventInfo(CEV_Timeofdayminute) > 60 then vEventInfo(CEV_Timeofdayminute) = 0
      if vEventInfo(CEV_Timeofdaymeridian) < 0 or vEventInfo(CEV_Timeofdaymeridian) > 1 then vEventInfo(CEV_Timeofdaymeridian) = 0
      if vEventInfo(CEV_Weekday) < 0 or vEventInfo(CEV_Weekday) > 7 then vEventInfo(CEV_Weekday) = 1
      if vEventInfo(CEV_Year) < 0 then
        bError = true
        dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORYEAR") & "<br/>"
      end if
      if vEventInfo(CEV_Day) < 0 or vEventInfo(CEV_Day) > 31 then
        bError = true
        dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORDAY") & "<br/>"
      end if
      if vEventInfo(CEV_Month) < 0 or vEventInfo(CEV_Month) > 12 then
        bError = true
        dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORMONTH") & "<br/>"
      end if

      if vEventInfo(CEV_HasDateRange) = 1 and vEventInfo(CEV_Recurrence) <> "none" then
        if not(IsDate(vEventInfo(CEV_startdaterange))) or not(IsDate(vEventInfo(CEV_enddaterange))) then
          bError = True
          dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORVALIDDATE") & "<br/>"
        else
          ' Swap dates if they're out of order
          if cDate(vEventInfo(CEV_startdaterange)) > (vEventInfo(CEV_enddaterange)) then BBS.Swap vEventInfo(CEV_startdaterange), vEventInfo(CEV_enddaterange)
          if vEventInfo(CEV_Recurrence) = "weekly" and ( cDate(vEventInfo(CEV_enddaterange)) - cDate(vEventInfo(CEV_startdaterange)) ) < 7 then
            bError = True
            dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORWEEKRANGE") & "<br/>"
          end if
          if vEventInfo(CEV_Recurrence) = "monthly" and ( cDate(vEventInfo(CEV_enddaterange)) - cDate(vEventInfo(CEV_startdaterange)) ) < 31 then
            bError = True
            dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORMONTHRANGE") & "<br/>"
          end if
          if vEventInfo(CEV_Recurrence) = "yearly" and ( cDate(vEventInfo(CEV_enddaterange)) - cDate(vEventInfo(CEV_startdaterange)) ) < 365 then
            bError = True
            dictEnvironment("V-MESSAGE") = dictEnvironment("V-MESSAGE") & dictLanguage("CALENDAR-ERRORYEARRANGE") & "<br/>"
          end if
        end if
      end if

      if bError = False and sAction = "postadd" then
        iNewID = Calendar.CreateEventInfo(vEventInfo)
        BBS.CacheDelete("INFO-EVENTS")
        response.redirect "event-view.asp?eventid=" & iNewID & "&year=" & vEventInfo(CEV_Year) & "&month=" & vEventInfo(CEV_Month)
      elseif bError = False and sAction = "postedit" then
        Calendar.UpdateEventInfo(vEventInfo)
        BBS.CacheDelete("INFO-EVENTS")
        response.redirect "event-view.asp?eventid=" & vEventInfo(CEV_CalendarEventID) & "&year=" & vEventInfo(CEV_Year) & "&month=" & vEventInfo(CEV_Month)
      elseif bError = True then
        ' The dates have been stored as.. dates.. Convert them to the specified BBS short format date
        vEventInfo(CEV_SingleDate) = BBS.GetShortDate(vEventInfo(CEV_SingleDate))
        vEventInfo(CEV_enddaterange) = BBS.GetShortDate(vEventInfo(CEV_enddaterange))
        vEventInfo(CEV_startdaterange) = BBS.GetShortDate(vEventInfo(CEV_startdaterange))
      end if


  end if

   ' Javascript for calendar
   sOutput = "<script type='text/javascript'>" & CRLF
   sOutput = sOutput & "Calendar.setup({" & CRLF
   sOutput = sOutput & "    inputField : 'singledate'," & CRLF
   sOutput = sOutput & "    ifFormat   : '" & BBS.GetCalendarDateFormat() & "'," & CRLF
   sOutput = sOutput & "    button     : 'singledate-trigger'," & CRLF
   sOutput = sOutput & "    align      : 'bR'" & CRLF
   sOutput = sOutput & "});" & CRLF
   sOutput = sOutput & "Calendar.setup({" & CRLF
   sOutput = sOutput & "    inputField : 'startdaterange'," & CRLF
   sOutput = sOutput & "    ifFormat   : '" & BBS.GetCalendarDateFormat() & "'," & CRLF
   sOutput = sOutput & "    button     : 'startdaterange-trigger'," & CRLF
   sOutput = sOutput & "    align      : 'bR'" & CRLF
   sOutput = sOutput & "});" & CRLF
   sOutput = sOutput & "Calendar.setup({" & CRLF
   sOutput = sOutput & "    inputField : 'enddaterange'," & CRLF
   sOutput = sOutput & "    ifFormat   : '" & BBS.GetCalendarDateFormat() & "'," & CRLF
   sOutput = sOutput & "    button     : 'enddaterange-trigger'," & CRLF
   sOutput = sOutput & "    align      : 'bR'" & CRLF
   sOutput = sOutput & "});" & CRLF
   sOutput = sOutput & "</script>" & CRLF
   dictEnvironment("V-CALENDARJS") = sOutput
   sOutput = ""

   dictEnvironment.add "V-TITLE", dictLanguage("CALENDAR-TITLE")
   dictEnvironment.add "V-DATEFORMAT", "(" & BBS.GetDateFormat(dictConfiguration("sDATEFORMAT")) & ")"
   dictEnvironment.add "V-EVENT", vEventInfo
   dictEnvironment.add "C-SHOWRANDOMQUOTES", dictConfiguration("bDISPLAYBBSQUOTES")
   if iBBSUserLevel >= USERLEVEL_SupportAdministrator then dictEnvironment.add "C-SHOWADMINLINK", 1
   if sPostAction = "postedit" then
     dictEnvironment("U-FORMACTION") = "add-event.asp?action=" & sPostAction & "&amp;eventid=" & vEventInfo(CEV_CalendarEventID) & "&amp;calendarid=" & vCalendarInfo(CI_CalendarID)
   else
     dictEnvironment("U-FORMACTION") = "add-event.asp?action=" & sPostAction & "&amp;calendarid=" & vCalendarInfo(CI_CalendarID)
   end if
   dictEnvironment("C-REGISTERED") = BBS.ValidateBoolean(iBBSUserLevel >= USERLEVEL_User)

%>
<!-- #include file="../includes/header.asp"-->
<% Filesystem.ExecuteBBSTemplate("/calendar/add-event.asp") %>
<!-- #include file="../includes/footer.asp" -->

