<%@ CodePage=65001 Language="VBScript"%>
<% Option Explicit %>
<!-- #include file="../includes/include.asp"-->
<!-- #include file="../includes/include-usermaintenance.asp"-->
<!-- #include file="../includes/include-alerts.asp"-->
<!-- #include file="../includes/include-messenger.asp"-->
<!-- #include file="../includes/include-forums.asp"-->
<% sBBSLangPage = "admin"
   BBS.SetupBBS
   BBS.SetScheme(0)

   if not(BBS.HasPermission(PERM_admineditusers,-1)) then response.redirect "../logon.asp?error=admin"

   dim UserID, sOutput, iActive, dLastLogon, dDateRegistered, sListUsername, sEmail, iStart, rank
   dim SQL, bError, vUserInfo, iPageSize, iRecordCount, iPage, iCurrentPage, iMove, sCriteria, sNewUsername
   dim sOldUsername, bReturn, iTotalPosts, iMemberID, bSendEmail, sTemplateEmail, bModeratedMember
   dim sCellColor, iNumberOfColumns, vPosts, index

   iNumberOfColumns = 7
   if dictConfiguration.item("bFORCEPOSTVALIDATION") = 1 then
     iNumberOfColumns = iNumberOfColumns + 1
   end if

   iStart = BBS.ValidateNumeric(request("start"))

   iPageSize = 100
   if request.querystring("active")="false" then
     iActive = 0
   else
     iActive = 1
   end if

   ' Is there any extra criteria for searches?
   if len(trim(request.form("searchuser"))) > 0 then
     sCriteria = sCriteria & " and username like '%" & BBS.ValidateSQL(trim(request.form("searchuser"))) & "%' "
   end if
   if len(trim(request.form("searchemail"))) > 0 then
     sCriteria = sCriteria & " and emailaddress like '%" & BBS.ValidateSQL(trim(request.form("searchemail"))) & "%' "
   end if
   if len(trim(request.querystring("username"))) > 0 then
     sCriteria = sCriteria & " and username='" & BBS.ValidateSQL(BBS.Canonize(trim(request.querystring("username")))) & "' "
   end if

   ' Delete selected users
   if request.form("action") = dictLanguage("ADMIN-163") then
     if BBS.HasPermission(PERM_admindeleteuser,-1) then
       for each UserID in request("userids")
         UserMaintenance.DeleteUserByID UserID, true, true, true
       next
     end if
   end if

   ' Ban / activate selected users
   if (request.form("action") = dictLanguage("ADMIN-149")) or (request.form("action") = dictLanguage("ADMIN-150")) then
     bSendEmail = request.form("sendemail") = "1"
     for each UserID in request.form("userids")
       vUserInfo = BBS.GetUserInfobyID(UserID)
       vUserInfo(UI_Active) = BBS.BooleanNot(vUserInfo(UI_Active))
       UserMaintenance.UpdateUser(vUserInfo)

       ' If the checkbox is toggled, then send the users a notification on their new status
       if bSendEmail then

         ' Decode the proper template
         if vUserInfo(UI_Active) then
           sTemplateEmail = BBS.DecodeTemplate(vUserInfo, dictLanguage("TEMPLATE-ACTIVATE"))
         else
           sTemplateEmail = BBS.DecodeTemplate(vUserInfo, dictLanguage("TEMPLATE-BANNED"))
         end if

         Messenger.SendMail dictConfiguration("sMAILSERVERADDRESS"), _
                   vUserInfo(UI_EmailAddr), _
                   dictConfiguration("sADMINEMAIL"), _
                   BBS.DecodeTemplate(vUserInfo, dictLanguage("TEMPLATE-ACCOUNTSTATUS")), _
                   sTemplateEmail, _
                   dictConfiguration("sEMAILCOMPONENT")
       end if

       ' If we've activated a user, remove any New User alerts about them
       if vUserInfo(UI_Active) = 1 then Alerts.DeleteAlertByMemberID ALERT_NewUser, vUserInfo(UI_MemberID)
     next
   end if

   ' Toggle posting status of selected users
   if request.form("action") = dictLanguage("ADMIN-315") then
     for each UserID in request.form("userids")
       vUserInfo = BBS.GetUserInfobyID(UserID)
       vUserInfo(UI_OKToPost) = BBS.BooleanNot(vUserInfo(UI_OKToPost))
       UserMaintenance.UpdateUser(vUserInfo)
     next
   end if

   ' Delete all messages by selected users
   if request.form("action") = dictLanguage("ADMIN-321") then
     for each UserID in request.form("userids")
       SQL = "select messageid from messages where memberid=" & UserID
       rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
       if not rsMaster.eof then
         vPosts = rsMaster.getrows
         rsMaster.close
         for index = 0 to ubound(vPosts, 2)
           Forum.DeleteMessage(vPosts(0, index))
         next
       else
         rsMaster.close
       end if
       BBS.AddQuery(SQL)
     next
   end if

   ' Get total number of members to display
   SQL = "select count(*) as usercount from members where active=" & iActive & sCriteria
   rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
   BBS.AddQuery(SQL)
   if not rsMaster.EOF then iRecordCount = rsMaster.fields(0).value
   rsMaster.Close

   ' Generate the paging box
   sOutput = "<table width='95%' align='center'><tr><td align='left'>"
   sOutput = sOutput & dictLanguage("ADMIN-151") & " <select class='bbsdropdownbox' name='start' size='1'>"
   iCurrentPage = 1
   iMove=0
   iPage = 1
   do until iMove >= iRecordCount
     sOutput = sOutput & "<option value='" & iMove & "'"
     if iPage = iCurrentPage then sOutput = sOutput & " SELECTED "
     sOutput = sOutput & ">" & iPage & "</option>" & CRLF
     iPage = iPage + 1
     iMove = iMove + iPageSize
   loop
   sOutput = sOutput & "</select> <input type='submit' class='bbsbutton' value='" & dictLanguage("GLOBAL-GO") & "'></td></tr></table>"
   dictEnvironment("V-PAGINGBOX") = sOutput
   sOutput = ""


   ' Rename a user
   if request("action") = dictLanguage("ADMIN-171") then
     sNewUsername = left(trim(request("renamedest")),20)
     sOldUsername = left(trim(request("renamesrc")),20)

     if not(BBS.UserExistsbyName(sOldUsername)) then
       bError = True
       dictEnvironment("V-MESSAGE") = dictLanguage("ADMIN-172")
     end if

     if BBS.UserExistsbyName(sNewUsername) and not LCase(sOldUsername) = LCase(sNewUsername) then
       bError = True
       dictEnvironment("V-MESSAGE") = dictLanguage("ADMIN-170")
     end if

     if bError = False then
       bReturn = Usermaintenance.Renameuser(sOldUsername, sNewUsername)
       if bReturn = True then
         dictEnvironment("V-MESSAGE") = dictLanguage("ADMIN-169")
         sNewUsername = ""
         sOldUsername = ""
       end if
     end if
   end if

   ' Sending an activation notice to a member
   sub SendActivationNotice(byref name, byVal sMessage)
     vUserInfo = BBS.GetUserInfo(name)
     if vUserInfo(UI_MemberID <> 0) then
       sMessage = DecodeTemplate(vUserInfo(UI_Username), sMessage)
       SendMail sMailServerAddress, vUserInfo(UI_Emailaddr), sAdminEmail, sBBSName & " : your account status", sMessage, sBBSEmailComponent
     end if
   end sub

   ' Create the userlisting
   rank = iStart

   if iActive=1 then
     dictEnvironment("V-TITLE")  = dictLanguage("ADMIN-146")
     dictEnvironment("V-ACTION") = dictLanguage("ADMIN-149")
   else
     dictEnvironment("V-TITLE")  = dictLanguage("ADMIN-147")
     dictEnvironment("V-ACTION") = dictLanguage("ADMIN-150")
   end if

   SQL = "select username, memberid, emailaddress, dateregistered, lastlogon, totalposts, oktopost from members where active=" & iActive & sCriteria & " order by username asc"
   rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
   BBS.AddQuery(SQL)

   if not rsMaster.EOF then
     vbString.Append      "<tr><td class='messagecellheader2'>&nbsp;</td>"
     vbString.Append   "<td class='messagecellheader2'>" & dictLanguage("GLOBAL-USERNAME") & "</td>"
     vbString.Append   "<td nowrap class='messagecellheader2'>" & dictLanguage("ADMIN-142") & "</td>"

     vbString.Append   "<td nowrap class='messagecellheader2'>" & dictLanguage("ADMIN-144") & "</td>"
     vbString.Append   "<td nowrap class='messagecellheader2'>" & dictLanguage("ADMIN-145") & "</td>"
     vbString.Append   "<td nowrap class='messagecellheader2'>&nbsp;</td>"
     if dictConfiguration.item("bFORCEPOSTVALIDATION") = 1 then
       vbString.Append   "<td nowrap class='messagecellheader2' nowrap>" & dictLanguage("GLOBAL-MODERATED") & "</td>"
     end if
     vbString.Append   "<td class='messagecellheader2' align='center'><a href='javascript: toggleusers()'>" & dictLanguage("ADMIN-162") & "</a></td>"
     vbString.Append   "</tr>"
   end if

   if not(rsMaster.EOF) then rsMaster.move iStart
   do until rsMaster.EOF or (rank = (iStart + iPagesize))
     rank              = rank + 1
     iMemberID         = rsMaster.fields("memberid").value
     sListUsername     = rsMaster.fields("username").value
     sEmail            = rsMaster.fields("emailaddress").value
     dDateRegistered   = rsMaster.fields("dateregistered").value
     dLastLogon        = rsMaster.fields("lastlogon").value
     iTotalPosts       = rsMaster.fields("totalposts").value
     bModeratedMember  = BBS.BooleanNot(rsMaster.fields("oktopost").value)

     if bModeratedMember = 1 and dictConfiguration.item("bFORCEPOSTVALIDATION") <> 1 then
       sCellColor = "messagecellbody2"
     else
       sCellColor = "messagecellbody"
     end if

     vbString.Append  "<tr><td class='" & sCellColor & "'>" & rank & "</td>"
     vbString.Append  "<td class='" & sCellColor & "'>" & BBS.CreateUsernameLinkbyID (iMemberID) & BBS.ValidateField(sListUsername) & "</a>  (<a href='user-editspecial.asp?uid=" & BBS.ValidateNumeric(iMemberID) & "'>" & dictLanguage("GLOBAL-EDIT") & "</a>)</td>"
     vbString.Append  "<td class='" & sCellColor & "' nowrap>" & BBS.MBBSDecode(BBS.GetUserRank(sListUsername), 1) & " / " & BBS.ValidateNumeric(iTotalPosts) & "</td>"
     vbString.Append  "<td class='" & sCellColor & "' nowrap>" & BBS.GetShortDate(dLastLogon) & "</td>"
     vbString.Append  "<td class='" & sCellColor & "' nowrap>" & BBS.ValidateField(sEmail) & "</td>"
     vbString.Append  "<td class='" & sCellColor & "' nowrap><a href='impersonate.asp?redirect=../profile/controlpanel.asp&uid=" & rsMaster("memberid") & "'>" & dictLanguage("ADMIN-148") & "</a></td>"
     if dictConfiguration.item("bFORCEPOSTVALIDATION") = 1 then
       if bModeratedMember = 1 then
         vbString.Append  "<td class='messagecellbody2' nowrap align='center'><b>" & dictLanguage("GLOBAL-YES") & "</b></td>"
       else
         vbString.Append  "<td class='messagecellbody' nowrap align='center'>" & dictLanguage("GLOBAL-NO") & "</td>"
       end if
     end if
     vbString.Append  "<td class='" & sCellColor & "' align='center'><input type='checkbox' name='userids' value='" & rsMaster.fields("memberid") & "'></td></tr>"
     rsMaster.MoveNext
   loop
   rsMaster.Close
   dictEnvironment("V-USERLIST") = vbString.ToString()
   vbString.Clear()
   sOutput = ""

%>

<!-- #include file="admin-include-header.asp" -->

<script type='text/javascript'><!--
function toggleusers()
{for (i=0;i<document.users.elements.length;i++)
    {if(document.users.elements[i].type=='checkbox' && document.users.elements[i].name=='userids')
         { if(document.users.elements[i].checked==true)
              {
               document.users.elements[i].checked=false;
              }
              else
              {
                document.users.elements[i].checked=true;
              }
}}}//--></script>

<div class='error' align='center'><%=dictEnvironment("V-MESSAGE")%></div><br/>
<form method="post" name='users' action="user-maintenance.asp?active=<%=request.querystring("active")%>">
<table class='bbstable' align='center' width='95%' cellspacing='1'>
<tr><td colspan='<%=iNumberOfColumns%>' class='messagecellheader'><%=dictLanguage("ADMIN-NAVBAR-39")%> - <%=dictEnvironment("V-TITLE")%></td></tr>
<%=dictEnvironment("V-USERLIST")%>
<tr><td colspan='8' class='messagecellfooter' align='right'>
<%=dictLanguage("ADMIN-311")%> <input type='checkbox' name='sendemail' value='1'>
</td></tr>
<tr><td colspan='8' class='messagecellfooter' align='left'>
<table width='100%'><tr>
<td align='left'><input name='action' onclick='return(confirm("<%=dictLanguage("ADMIN-164")%>"))' type='submit' class='bbsbutton' value='<%=dictLanguage("ADMIN-163")%>'></td>
<% if dictConfiguration.item("bFORCEPOSTVALIDATION") = 1 then %>
<td align='center'><input name='action' type='submit' class='bbsbutton' value='<%=dictLanguage("ADMIN-315")%>'></td>
<% end if %>
<td align='center'><input name='action' type='submit' class='bbsbutton' value='<%=dictLanguage("ADMIN-321")%>'></td>
<td align='right'><input name='action' type='submit' class='bbsbutton' value='<%=dictEnvironment("V-ACTION")%>'></td>
</tr></table>
</td></tr>
</table>
</form>
<form method="post" name='userspaging' action="user-maintenance.asp?active=<%=request.querystring("active")%>">
<input type='hidden' name='searchuser' value='<%=request.form("searchuser")%>'>
<input type='hidden' name='searchemail' value='<%=request.form("searchemail")%>'>
<%=dictEnvironment("V-PAGINGBOX")%>
</form>
<br/>

<form method="post" name='search' action="user-maintenance.asp?active=<%=request.querystring("active")%>">
<table width='95%' align='center' cellspacing='0'>
  <tr><td>
    <form method="post" name='search' action="user-maintenance.asp?active=<%=request.querystring("active")%>">
    <table class='bbstable' cellspacing='1'>
    <tr><td colspan='2' class='messagecellheader2'><%=dictLanguage("ADMIN-165")%></td></tr>
    <tr>
      <td class="messagecellbody"><%=dictLanguage("GLOBAL-USERNAME")%></td>
      <td class='messagecellbody'><input type='text' size='20' maxlength='20' name='searchuser' value='<%=request.form("searchuser")%>'></td></tr>
    <tr>
      <td class='messagecellbody'><%=dictLanguage("GLOBAL-EMAIL")%></td>
      <td class='messagecellbody'><input type='text' size='20' maxlength='100' name='searchemail' value='<%=request.form("searchemail")%>'></td></tr>
    <tr><td class='messagecellfooter' colspan='2' align='center'><input type='submit' name='action' value='<%=dictLanguage("GLOBAL-SEARCH")%>' class='bbsbutton'></td></tr>
    </table>
    </form>
  </td><td align='right'>
      <form method="post" name='rename' action="user-maintenance.asp?active=<%=request.querystring("active")%>">
      <table cellspacing='1' class='bbstable' cellspacing='" & dictTemplate("CELLSPACING") & "'>
        <tr><td colspan='2' class='messagecellheader2'><%=dictLanguage("ADMIN-166")%></td></tr>
        <tr><td class='messagecellbody'><%=dictLanguage("ADMIN-167")%></td>
            <td class='messagecellbody'><input type='text' size='20' maxlength='20' name='renamesrc' value='<%=sOldUsername%>'></td></tr>
        <tr><td class='messagecellbody'><%=dictLanguage("ADMIN-168")%></td>
            <td class='messagecellbody'><input type='text' size='20' maxlength='20' name='renamedest' value='<%=sNewUsername%>'></td></tr>
        <tr><td colspan='2' class='messagecellfooter' align='center'><input type='submit' default name='action' value='<%=dictLanguage("ADMIN-171")%>' class='bbsbutton'></td></tr></table>
      </form>
  </td></tr>
</table>
<br/>
<br/>
<table width='95%' align='center' cellspacing='1'>
  <tr><td align='right'>
  <table cellspacing='<%=dictTemplate("CELLSPACING")%>' class='bbstable'>
  <tr><td class='messagecellheader2'><%=dictLanguage("GLOBAL-ACTIONS")%></td></tr>
  <tr><td class="messagecellbody">
    <a href="user-maintenance.asp?active=true"><%=dictLanguage("ADMIN-146")%></a><br/>
    <a href="user-maintenance.asp?active=false"><%=dictLanguage("ADMIN-147")%></a><br/>
	<a href="list-emails.asp">List all e-mail addresses</a><br/>
    <a href="user-addaccount.asp"><%=dictLanguage("ADMIN-NAVBAR-39.2")%></a><br/>
  </td></tr></table>
</td></tr>
</table>

<!-- #include file="admin-include-footer.asp" -->