<%@ CodePage=65001 Language="VBScript"%>
<% Option Explicit %>
<!-- #include file="../includes/include.asp"-->
<!-- #include file="../includes/include-forums.asp"-->
<% sBBSLangPage = "forum-view"
   BBS.SetupBBS

   dim iForumID, iBookmark, sDisplayForm, vCategoryInfo, vThreadRows, vThreadInfo, vForumInfo, vUserInfo, sForumViewMode, sOrder, SQL, iUpperBound, stDisplayInfo
   dim sThreadFilter, bHasSticky, iTop, iDayFilter, vbForums, sThreadLink, sLastThreadLink, sSpecialImage

   ' Threadrow
   dim sImageLink, sOwner, sLastPoster, iNumFLatPages, index, sFlatPaging, indexPaging, sLastThreadSubject

   set vbForums = new StringBuilder
   iforumid  = BBS.ValidateNumeric(request.querystring("fid"))
   iBookmark = BBS.Maximum(BBS.ValidateNumeric(request("bookmark")), 1)
   bHasSticky   = False

   ' Get information about this forum
   vForumInfo = Forum.GetForumInfo (iforumid)
   if vForumInfo(FI_ForumID) < 1 then response.redirect sBBSForumRoot & "/category-view.asp"
   vCategoryInfo = BBS.GetCategoryInfo (vForumInfo(FI_CategoryID))

   if vCategoryInfo(CA_Locked) = 1 then
     response.cookies(sBBSCookieRoot & "catlock") = vCategoryInfo(CA_CategoryID)
   end if
   BBS.SetScheme(vCategoryInfo(CA_CategoryID))

   ' Check for permission to view this forum
   if not(BBS.HasPermission(PERM_FORUMACCESS, iForumID)) then response.redirect sBBSForumRoot & "/restricted-page.asp"
   vUserInfo = BBS.GetUserInfobyID(iBBSMemberID)

   ' Deterimine the active viewing method (in order of preference)
   ' If the user has supplied a viewing mode via the querystring, then use this mode and set the cookie
   ' If the user has already has a cookied preference, use that
   ' If the user has no cookied preference, use their profile default
   ' If the user still has not chosen a mode, use the forum default

   if BBS.ValidateNumeric(request.form("setdisplay")) = 1 then
     response.cookies(sBBSCookieRoot & "threadsort")  = BBS.ValidateNumeric(request.form("threadsort"))
     response.cookies(sBBSCookieRoot & "yearfilter")  = BBS.ValidateNumeric(request.form("yearfilter"))
     response.cookies(sBBSCookieRoot & "monthfilter") = BBS.ValidateNumeric(request.form("monthfilter"))
     response.cookies(sBBSCookieRoot & "dayfilter")   = BBS.ValidateNumeric(request.form("dayfilter"))
     iDayFilter = BBS.ValidateNumeric(request.form("dayfilter"))

     if BBS.ValidateNumeric(request.form("dayfilter")) > 0 then
       response.cookies(sBBSCookieRoot & "yearfilter")  = 0
       response.cookies(sBBSCookieRoot & "monthfilter") = 0
     end if
   end if


   if BBS.ValidateNumeric(sBBSCookieRoot & request.cookies("dayfilter")) = 0 then
     ' Default to all days
     iDayFilter = -1
   else
     iDayFilter = request.cookies(sBBSCookieRoot & "dayfilter")
   end if

   if len(request.querystring("DisplayType")) > 0 then
     sForumViewMode = request.querystring("displaytype")
     if request.querystring("setcookie") = "1" then response.cookies(sBBSCookieRoot & "ForumViewMode") = sForumViewMode
   elseif len(sBBSForumViewMode) > 0 then
     sForumViewMode = sBBSForumViewMode
   elseif iBBSLogonType = US_Registered then
     sForumViewMode = vUserInfo(UI_defaultforumview)
   end if

   if len(sForumViewMode) = 0 or sForumViewMode = "default" then
     sForumViewMode = vForumInfo(FI_defaultforumview)
   elseif sForumViewMode <> "threaded" and sforumviewmode <> "flat" then
     sForumViewMode = "flat"
   end if

   if len(sForumViewMode) = 0 then sForumViewMode = "flat"

   if vForumInfo(FI_SortByActivity) = 1 then
     if BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "threadsort")) = 1 then
       sOrder = " threads.sticky desc, threads.lastactivity asc"
     else
       sOrder = " threads.sticky desc, threads.lastactivity desc "
     end if
   else
     sOrder = " threads.sticky desc, threads.threadid desc "
   end if

   ' Common flat/thread page variables
   sDisplayForm = sDisplayForm & "<form name='container' action='forum-view.asp' method='get'><input type='hidden' name='setcookie' value='1'><input type='hidden' name='fid' value='" & vForumInfo(FI_ForumID) & "'><select class='bbsdropdownbox' name='DisplayType' onchange='updateCookie()' size='1'>"
   if sForumViewMode = "flat" then
     sDisplayForm = sDisplayForm & "<option selected value='flat'>" & dictLanguage.item("FORUM-3") & "</option><option value='threaded'>" & dictLanguage.item("FORUM-4") & "</option>"
   else
     sDisplayForm = sDisplayForm & "<option value='flat'>" & dictLanguage.item("FORUM-3") & "</option><option selected value='threaded'>" & dictLanguage.item("FORUM-4") & "</option>"
   end if
   sDisplayForm = sDisplayForm & "</select>&nbsp;<input type='submit' class='bbsbutton' value='" & dictLanguage("GLOBAL-GO") & "'></form>"

   ' Thread filter modifications sponsored by computational hydraulics.
   vbString.Append "<script type='text/javascript'>" & CRLF
   vbString.Append  "function togglemonths(){" & CRLF
   vbString.Append  " if (document.getElementById(""yearfilter"").selectedIndex ==0) " & CRLF
   vbString.Append  "   document.getElementById(""monthfilter"").selectedIndex = 0" & CRLF
   vbString.Append  "}" & CRLF
   vbString.Append  "</script>" & CRLF
   vbString.Append  "" & CRLF

   vbString.Append  "<form name='container2' action='forum-view.asp?fid=" & vForumInfo(FI_ForumID) & "' method='post'><input type='hidden' name='setdisplay' value='1'><input type='hidden' name='dayfilter' value='-1'>"
   if vForumInfo(FI_SortByActivity) = 1 then
     vbString.Append  dictLanguage("FORUM-SORTTHREADS") & " <select class='bbsdropdownbox' name='threadsort'><option " & BBS.IsSelected(BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "threadsort"))=0) & " value='0'>" & dictLanguage("GLOBAL-DESC") & "</option>"
     vbString.Append  "<option " & BBS.IsSelected(BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "threadsort"))=1) & " value='1'>" & dictLanguage("GLOBAL-ASC") & "</option></select><br/>"
   end if
   vbString.Append  dictLanguage("FORUM-FILTERBYDATE") & "  <select id='yearfilter' onclick='togglemonths()' class='bbsdropdownbox' name='yearfilter'>"
   vbString.Append  "<option  value='0' " & BBS.IsSelected(BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "yearfilter"))=0) & ">" & dictLanguage("FORUM-ALLYEARS") & "</option>"
   for index=0 to 9
     vbString.Append  "<option value='" & year(now)-index & "' " & BBS.IsSelected(BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "yearfilter"))=year(now)-index) & ">" & year(now)-index & "</option>"
   next
   vbString.Append  "</select> "
   vbString.Append  " <select onclick='togglemonths()' id='monthfilter' class='bbsdropdownbox' name='monthfilter'>"
   vbString.Append  "<option value='0' " & BBS.IsSelected(BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "monthfilter"))=0) & ">" & dictLanguage("FORUM-ALLMONTHS") & "</option>"
   for index=1 to 12
     vbString.Append  "<option value='" & index & "' " & BBS.IsSelected(BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "monthfilter"))=index)& ">" & BBS.Months(index) & "</option>"
   next
   vbString.Append  "</select>&nbsp;<input type='submit' class='bbsbutton' value='" & dictLanguage("GLOBAL-GO") & "'></form>"

   vbString.Append  "<form name='container3' action='forum-view.asp?fid=" & vForumInfo(FI_ForumID) & "&amp;bookmark=" & iBookmark & "' method='post'><input type='hidden' name='setdisplay' value='1'>" & dictLanguage("FORUM-DAYSFILTER") & " : "
   vbString.Append  " <select onchange='this.form.submit()' id='dayfilter' class='bbsdropdownbox' name='dayfilter'>"
   vbString.Append  "<option value='-1' " & BBS.IsSelected(iDayFilter = -1) & ">" & dictLanguage("FORUM-ALLDAYS") & "</option>"
   vbString.Append  "<option value='5' " & BBS.IsSelected(iDayFilter = 5)& ">" & 5 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "<option value='15' " & BBS.IsSelected(iDayFilter = 15)& ">" & 15 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "<option value='30' " & BBS.IsSelected(iDayFilter = 30)& ">" & 30 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "<option value='60' " & BBS.IsSelected(iDayFilter = 60)& ">" & 60 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "<option value='90' " & BBS.IsSelected(iDayFilter = 90)& ">" & 90 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "<option value='240' " & BBS.IsSelected(iDayFilter = 240)& ">" & 240 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "<option value='365' " & BBS.IsSelected(iDayFilter = 365)& ">" & 365 & " " & dictLanguage("FORUM-DAYS") & "</option>"
   vbString.Append  "</select>&nbsp;<input type='submit' class='bbsbutton' value='" & dictLanguage("GLOBAL-GO") & "'></form>"

   dictEnvironment("V-THREADFILTER") = vbString.ToString()
   vbString.Clear

   dictEnvironment.add "V-FORUM", vForumInfo
   dictEnvironment.add "V-CATEGORY", vCategoryInfo
   dictEnvironment.add "C-VIEWMODE", sForumViewMode
   dictEnvironment.add "C-CREATEPOLL", BBS.ValidateBoolean(BBS.HasPermission(PERM_forumcreatepoll, vForumInfo(FI_ForumID)))
   dictEnvironment.add "C-POSTNEW", BBS.ValidateBoolean(BBS.HasPermission(PERM_forumnewthread,  vForumInfo(FI_ForumID)))
   dictEnvironment.add "C-RESTRICTEDFORUM", BBS.BooleanNot(BBS.LookupPermission(MODULE_FORUMS, USERLEVEL_User, PERM_FORUMACCESS, vForumInfo(FI_ForumID)))
   dictEnvironment.add "C-RSS", BBS.ValidateBoolean((vForumInfo(FI_RSS) = 1) and (bFeaturesUnlocked = 1))
   dictEnvironment.add "V-MESSAGEFORMATCHOOSER", sDisplayForm
   dictEnvironment.add "V-MODERATORLIST", BBS.ListMembers (MODULE_FORUMS, USERLEVEL_Moderator, vForumInfo(FI_ForumID))
   dictEnvironment.add "U-FORUMLINK", sBBSForumRoot & "/forums/forum-view.asp?fid=" & vForumInfo(FI_ForumID)
   if clng(iBBSCatLock) = clng(vCategoryInfo(CA_CategoryID)) then
     dictEnvironment.add "U-CATEGORYLINK", sBBSForumRoot & "/category-view.asp?catlock=" & vCategoryInfo(CA_CategoryID)
   else
     dictEnvironment.add "U-CATEGORYLINK", sBBSForumRoot & "/category-view.asp?showall=true"
   end if
   dictEnvironment.add "U-CATEGORYLINKALL", sBBSForumRoot & "/category-view.asp?action=showall"
   dictEnvironment.add "U-POSTLINK", sBBSForumRoot & "/forums/thread-post.asp?fid=" & iforumid & "&amp;action=writenew&amp;displaytype=" & BBS.ValidateField(sForumViewMode)
   dictEnvironment.add "U-POLLLINK", sBBSForumRoot & "/pollbooth/create-poll.asp?fid=" & iforumid
   dictEnvironment.add "U-SEARCH", sBBSForumRoot & "/search/query.asp?fid=" & iforumid
   dictEnvironment.add "U-RSS", sBBSForumRoot & "/forums/rss.asp?fid=" & iForumID
   dictEnvironment.add "V-PAGINGDROPDOWN", Forum.GeneratePagingDropdown (vForumInfo(FI_ForumID), iBookmark, sForumViewMode, "LIST")

   dictEnvironment.add "V-TITLE", dictLanguage("FORUM-TITLE") & " - " & vForumInfo(FI_ForumName)
   dictEnvironment.add "C-SHOWRANDOMQUOTES", vForumInfo(FI_ShowQuotes)
   if iBBSUserLevel >= USERLEVEL_SupportAdministrator then dictEnvironment.add "C-SHOWADMINLINK", 1

  if dictEnvironment("V-FORUM")(FI_shownavbars) = 1 then
    dictEnvironment("V-FORUMLOCATION") = "&nbsp;<a href='" & dictEnvironment("U-CATEGORYLINK")& "'>" & dictEnvironment("V-CATEGORY")(CA_CategoryName) & "</a>"
    if dictEnvironment("V-CATEGORY")(CA_Locked) = 1 then
      dictEnvironment("V-FORUMLOCATION") = dictEnvironment("V-FORUMLOCATION") & "&nbsp;(<a href='" & dictEnvironment("U-CATEGORYLINKALL") &"'>" & dictLanguage("FORUM-2") & "</a>)"
    end if
    dictEnvironment("V-FORUMLOCATION") = dictEnvironment("V-FORUMLOCATION") & " -> " & dictEnvironment("V-FORUM")(FI_ForumName)
    dictEnvironment("V-LOCATIONLINKS") = dictEnvironment("V-LOCATIONLINKS") & " -> " & dictEnvironment("V-FORUMLOCATION")
  end if

  dictEnvironment("C-EXTRAHEADTAG") = "<script type='text/javascript'>function updateCookie() {" & CRLF & _
                                      "  sForumViewMode = document.container.DisplayType.options[document.container.DisplayType.selectedIndex].value;" & CRLF & _
                                      "  document.cookie = """ & sBBSCookieRoot & "ForumViewMode="" + sForumViewMode + ""; path=/;"";" & CRLF & _
                                      "  NewURL = document.location.pathname + ""?fid=" & vForumInfo(FI_ForumID) & "&DisplayType="" + sForumViewMode + ""&setCookie=1"";" & CRLF & _
                                      "  window.location = NewURL;" & CRLF & _
                                      "}</script>" & CRLF



  ' ===========================================
  ' Generate the code for the flat viewing mode
  ' ===========================================
  if sForumViewMode = "flat" then

    if ucase(sBBSDatabaseType) <> "MYSQL" Then
      iTop = iBookMark + dictConfiguration("iFORUMTHREADPAGESIZE")
      if iTop < 20 then iTop = 21
      SQL = "SELECT top " & iTop & " threadid, forumid, totalposts, datecreated, lastactivity, threadsubject, anonymous, closed, timesviewed, sticky, haspoll, pollid, hasattachment, lastposteranonymous, lastpostermemberid, lastposterisregistered, lastposterguestname, memberid, isregistered, guestname, approved, seed, lastpostid from threads where forumid=" & vForumInfo(FI_ForumID)
    else
      SQL = "SELECT threadid, forumid, totalposts, datecreated, lastactivity, threadsubject, anonymous, closed, timesviewed, sticky, haspoll, pollid, hasattachment, lastposteranonymous, lastpostermemberid, lastposterisregistered, lastposterguestname, memberid, isregistered, guestname, approved, seed, lastpostid from threads where forumid=" & vForumInfo(FI_ForumID)
    end if

    if not(BBS.CanViewAllPosts(vForumInfo(FI_ForumID))) then
      SQL = SQL & " and approved=1"
    end if

    if BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "yearfilter")) > 0 then

      if BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "monthfilter")) > 0 then

        SQL = SQL & " and ((lastactivity>=" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter"), request.cookies(sBBSCookieRoot & "monthfilter"), 1)) & sDateDelimiter & " "
        SQL = SQL & " and lastactivity<" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter"), request.cookies(sBBSCookieRoot & "monthfilter")+1, 1)) & sDateDelimiter & ") or sticky=1) "

      else

        SQL = SQL & " and ((lastactivity>=" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter"), 1, 1)) & sDateDelimiter & " "
        SQL = SQL & " and lastactivity<" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter")+1, 1, 1)) & sDateDelimiter & ") or sticky=1) "

      end if

    elseif iDayFilter > 0 then
      ' Limit by days
      SQL = SQL & " and ((lastactivity>=" & sDateDelimiter & BBS.GetSQLDate(dateadd("D", iDayFilter * -1, now)) & sDateDelimiter & ") or sticky=1) "
    end if

    SQL = SQL & " order by " & sOrder

    rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
    BBS.AddQuery(SQL)

    ' Move to the bookmark
    if not(rsMaster.EOF) then rsMaster.move (iBookmark-1)

    if rsMaster.EOF then
      iUpperBound = -1
    else
      vThreadRows = rsMaster.GetRows(BBS.ValidateNumeric(dictConfiguration("iFORUMTHREADPAGESIZE")))
      iUpperBound = UBOUND(vThreadRows, 2)
    end if
    rsMaster.Close
    vThreadInfo = Forum.GetThreadInfoStruct()

    for index=0 to iUpperBound
      vThreadInfo(TI_ThreadID)              = vThreadRows(0,index)
      vThreadInfo(TI_ForumID)               = vThreadRows(1,index)
      vThreadInfo(TI_TotalPosts)            = vThreadRows(2,index)
      vThreadInfo(TI_DateCreated)           = vThreadRows(3,index)
      vThreadInfo(TI_LastActivity)          = vThreadRows(4,index)
      vThreadInfo(TI_Subject)               = vThreadRows(5,index)
      vThreadInfo(TI_Anonymous)             = vThreadRows(6,index)
      vThreadInfo(TI_Closed)                = vThreadRows(7,index)
      vThreadInfo(TI_TimesViewed)           = vThreadRows(8,index)
      vThreadInfo(TI_Sticky)                = vThreadRows(9,index)
      vThreadInfo(TI_HasPoll)               = vThreadRows(10,index)
      vThreadInfo(TI_PollID)                = vThreadRows(11,index)
      vThreadInfo(TI_HasAttachment)         = vThreadRows(12,index)
      vThreadInfo(TI_LastPosterAnonymous)   = vThreadRows(13,index)
      vThreadInfo(TI_LastPosterMemberID)    = vThreadRows(14,index)
      vThreadInfo(TI_LastPosterIsRegistered)= vThreadRows(15,index)
      vThreadInfo(TI_LastPosterGuestName)   = vThreadRows(16,index)
      vThreadInfo(TI_MemberID)              = vThreadRows(17,index)
      vThreadInfo(TI_IsRegistered)          = vThreadRows(18,index)
      vThreadInfo(TI_GuestName)             = vThreadRows(19,index)
      vThreadInfo(TI_Approved)              = vThreadRows(20,index)
      vThreadInfo(TI_Seed)                  = vThreadRows(21,index)
      vThreadInfo(TI_LastPostID)            = vThreadRows(22,index)

      if vThreadInfo(TI_Closed) = 1 then
       if vThreadInfo(TI_TotalPosts) > 20 then
        sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-CLOSED-HOT") & "'>"
       else
        sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-CLOSED") & "'>"
       end if
      else
        if iBBSLogonType = US_Registered then
          if vThreadInfo(TI_LastActivity) > vUserInfo(UI_LastLogon) then
           if vThreadInfo(TI_TotalPosts) > 20 then
            sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-OPEN-NEW-HOT") & "'>"
           else
            sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-OPEN-NEW") & "'>"
           end if
          else
           if vThreadInfo(TI_TotalPosts) > 20 then
            sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-OPEN-HOT") & "'>"
           else
            sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-OPEN") & "'>"
           end if
          end if
        else
         if vThreadInfo(TI_TotalPosts) > 20 then
          sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-OPEN-HOT") & "'>"
         else
          sImageLink = "<img alt='' border='0' src='" & dictImages("THREAD-OPEN") & "'>"
         end if
        end if
      end if

      if vThreadInfo(TI_Sticky) = 1 then
        sSpecialImage = "<img border='0' src='" & dictImages("THREAD-STICKY") & "' alt='" & dictLanguage("GLOBAL-STICKY") & "'>"
      elseif vThreadInfo(TI_HasPoll) = 1 then
        sSpecialImage = "<img border='0' src='" & dictImages("THREAD-POLL") & "' alt='" & dictLanguage("GLOBAL-POLL") & "'>"
      else
        sSpecialImage = ""
      end if


      if vThreadInfo(TI_IsRegistered) = 1 and vThreadInfo(TI_Anonymous) = 0 then
        sOwner = BBS.CreateUsernameLinkbyID(vThreadInfo(TI_MemberID)) & BBS.ValidateField(BBS.ValidateField(vThreadInfo(TI_GuestName))) & "</a>"
      elseif vThreadInfo(TI_IsRegistered) = 0 and vThreadInfo(TI_Anonymous) = 0 then
        sOwner= "<span class='notregisteredname'>" & BBS.ValidateField(vThreadInfo(TI_GuestName)) & "</span>"
      elseif vThreadInfo(TI_Anonymous) = 1 then
        sOwner= "<span class='notregisteredname'>" & dictLanguage("GLOBAL-ANONYMOUS") & "</span>"
      end if


      if vThreadInfo(TI_LastPosterIsRegistered) = 1 and vThreadInfo(TI_LastPosterAnonymous) = 0 then
        sLastPoster = BBS.CreateUsernameLinkbyID(vThreadInfo(TI_LastPosterMemberID)) & BBS.ValidateField(vThreadInfo(TI_LastPosterGuestname)) & "</a>"
      elseif vThreadInfo(TI_LastPosterIsRegistered) = 0 and vThreadInfo(TI_LastPosterAnonymous) = 0 then
        sLastPoster = "<span class='notregisteredname'>" & BBS.ValidateField(vThreadInfo(TI_LastPosterGuestname)) & "</span>"
      elseif vThreadInfo(TI_LastPosterAnonymous) = 1 then
        sLastPoster = "<span class='notregisteredname'>" & dictLanguage("GLOBAL-ANONYMOUS") & "</span>"
      end if

      ' Generate a thread paging bar
      sFlatPaging = ""
      if BBS.ValidateNumeric(dictConfiguration("iFORUMFLATPAGESIZE")) > 0 then
        iNumFLatPages = int((vThreadInfo(TI_TotalPosts)-1) / dictConfiguration("iFORUMFLATPAGESIZE")) + 1

        if iNumFlatPages >= 2 and iNumFlatPages <= 4 then
          sFlatPaging = " (" & dictLanguage.item("FORUM-16") & ": <a class='threadlink' href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=1'>1</a>, "
          for indexPaging = 2 to iNumFlatPages
            if indexPaging = iNumFlatPages Then
             sFlatPaging = sFlatPaging & "<a class='threadlink' href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=" & BBS.ValidateNumeric(dictConfiguration("iFORUMFLATPAGESIZE")) * (indexPaging-1) + 1 & "&amp;posts=" & vThreadInfo(TI_TotalPosts) & "'>" & indexPaging & "</a>"
            else
             sFlatPaging = sFlatPaging & "<a class='threadlink' href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=" & BBS.ValidateNumeric(dictConfiguration("iFORUMFLATPAGESIZE")) * (indexPaging-1) + 1 & "&amp;posts=" & vThreadInfo(TI_TotalPosts) & "'>" & indexPaging & "</a>, "
            end if
          next
          sFlatPaging = sFlatPaging & ")"
        elseif iNumFlatPages > 4 then
          sFlatPaging = " (" & dictLanguage.item("FORUM-16") & ": <a class='threadlink' href='thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=1'>1...</a> "
          sFlatPaging = sFlatPaging & "<a class='threadlink' href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=" & BBS.ValidateNumeric(dictConfiguration("iFORUMFLATPAGESIZE")) * (iNumFlatPages-3) + 1 & "'>" & (iNumFlatPages-2) & "</a> "
          sFlatPaging = sFlatPaging & "<a class='threadlink' href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=" & BBS.ValidateNumeric(dictConfiguration("iFORUMFLATPAGESIZE")) * (iNumFlatPages-2) + 1 & "'>" & (iNumFlatPages-1) & "</a> "
          sFlatPaging = sFlatPaging & "<a class='threadlink' href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;start=" & BBS.ValidateNumeric(dictConfiguration("iFORUMFLATPAGESIZE")) * (iNumFlatPages-1) + 1 & "&amp;posts=" & vThreadInfo(TI_TotalPosts) & "'>" & (iNumFlatPages) & "</a>)"
        end if
      end if

      sThreadLInk = sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;posts=" & vThreadInfo(TI_TotalPosts)
      sLastThreadLink = sThreadLInk & "#M"  & BBS.ValidateField(vThreadInfo(TI_LastPostID))

      if vThreadInfo(TI_Sticky) = 1 and bHasSticky = False then
       bHasSTicky = True
       ' ANNOUNCEMENTS
       vbForums.append("<tr><td class='messagecellheader2' colspan='7'>" & dictLanguage("GLOBAL-ANNOUNCEMENTS") & "</td></tr>")
       sBBSFragmentOutput = ""
      end if

      if vThreadInfo(TI_Sticky) = 0 and bHasSticky = True then
       bHasSTicky = False
       ' FORUM SPACER BETWEEN ANNOUNCEMENTS AND NORMAL ROWS
       vbForums.append("<tr><td class='messagecellbody2' colspan='7'>&nbsp;</td></tr>")
      end if

      ' FORUM ROW
      vbForums.append "<tr><td class='messagecellbody'>" & sImageLink & "</td>"
      vbForums.append "<td class='messagecellbody'>" & sSpecialImage & "</td>"
      vbForums.append "<td class='messagecellbody'>"
      if vThreadInfo(TI_HasAttachment) = 1 then
        vbForums.append "<img alt='' src='" & dictImages("FILE-ATTACH-SMALL") & "'> "
      end if
      if vThreadInfo(TI_Approved) = 0 then
        vbForums.append "<a class='threadlink' href='" & sThreadLink & "&amp;start=1'>" & BBS.ValidateField(vThreadInfo(TI_Subject)) & "</a><br><span class='header6 error'>[" & dictLanguage("GLOBAL-UNAPPROVED") & "]</span>"
      else
        vbForums.append "<a class='threadlink' href='" & sThreadLink & "&amp;start=1'>" & BBS.ValidateField(vThreadInfo(TI_Subject)) & "</a>"
      end if
      if len(sFlatPaging) > 0 then vbForums.append "<span class='smalltext'>" & sFlatPaging & "</span>"
      vbForums.append "</td>"
      vbForums.append "<td nowrap align='center' class='messagecellbody2 smalltext'>" & sOwner & "</td>"
      vbForums.append "<td align='center' class='messagecellbody2'>" & vThreadInfo(TI_TimesViewed) & "</td>"
      vbForums.append "<td align='center' class='messagecellbody2'>" & vThreadInfo(TI_TotalPosts)-1 & "</td>"
      vbForums.append "<td nowrap class='messagecellbody2 smalltext'>"
      vbForums.append "<a href='" & sBBSForumRoot & "/forums/thread-view.asp?tid=" & vThreadInfo(TI_ThreadID) & "&amp;posts=" & vThreadInfo(TI_TotalPosts) & "&amp;start=1' title='" & dictLanguage("GLOBAL-VIEWSTART") & "'><img border='0' src='" & dictImages("NAV-MESSAGES") & "' alt='" & dictLanguage("GLOBAL-VIEWSTART") & "'></a> " & DictLanguage("FORUM-14") & " : "
      vbForums.append BBS.GetShortDateTime(vThreadInfo(TI_LastActivity)) & "<br/> > " & dictLanguage("FORUM-BY") & " " & sLastPoster & "&nbsp;<a href='" & sLastThreadLink & "'><img alt='' border='0' src='" & dictImages("THREAD-GOTO") & "'></a>"
      vbForums.append "</td></tr>"


    next
   dictEnvironment.add "V-FORUMROWS", vbForums.ToString()
   vbForums.Clear()
   sBBSFragmentOutput = ""

   ' FLAT HEADER
   dictEnvironment("V-FLAT-HEADER") = "<table class='bbstable' cellspacing='" & dictTemplate("CELLSPACING") & "' width='95%' align='center'><tr>" & _
                                      "<td class='messagecellheader'>&nbsp;</td>" & _
                                      "<td class='messagecellheader'>&nbsp;</td>" & _
                                      "<td class='messagecellheader' nowrap width='100%' align='center'>" & dictLanguage("FORUM-10") & "</td>" & _
                                      "<td class='messagecellheader' nowrap align='center'>" & dictLanguage("FORUM-11") & "</td>" & _
                                      "<td class='messagecellheader' nowrap align='center'>"& dictLanguage("FORUM-12") & "</td>" & _
                                      "<td class='messagecellheader' nowrap align='center'>"& dictLanguage("FORUM-13") & "</td>" & _
                                      "<td class='messagecellheader' nowrap align='center'>"& dictLanguage("FORUM-14") & "</td></tr>"


   ' FLAT FOOTER
   dictEnvironment.add "V-FORUMFOOTER", "<tr><td colspan='7' class='messagecellfooter'> </td></tr></table>"


  elseif sForumViewMode = "threaded" then
  ' ===========================================
  ' Generate the code for the threaded viewing mode
  ' ===========================================

    stDisplayInfo = Forum.GetThreadInfoStruct()

    ' Loop through all the threads in this forum
    SQL = "SELECT threadid, sticky from threads where forumid=" & BBS.ValidateNumeric(vForumInfo(FI_ForumID))

    if not(BBS.CanViewAllPosts(vForumInfo(FI_ForumID))) then
      SQL = SQL & " and approved=1 "
    end if

    if BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "yearfilter")) > 0 then

      if BBS.ValidateNumeric(request.cookies(sBBSCookieRoot & "monthfilter")) > 0 then

        SQL = SQL & " and lastactivity>=" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter"), request.cookies(sBBSCookieRoot & "monthfilter"), 1)) & sDateDelimiter & " "
        SQL = SQL & " and lastactivity<" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter"), request.cookies(sBBSCookieRoot & "monthfilter")+1, 1)) & sDateDelimiter & " "


      else

        SQL = SQL & " and lastactivity>=" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter"), 1, 1)) & sDateDelimiter & " "
        SQL = SQL & " and lastactivity<" & sDateDelimiter & BBS.GetSQLDate(dateserial(request.cookies(sBBSCookieRoot & "yearfilter")+1, 1, 1)) & sDateDelimiter & " "

      end if

    elseif iDayFilter > 0 then
      ' Limit by days
      SQL = SQL & " and lastactivity>=" & sDateDelimiter & BBS.GetSQLDate(dateadd("D", iDayFilter * -1, now)) & sDateDelimiter & " "
    end if


    SQL = SQL & " order by " & sOrder

    rsMaster.open SQL, dbConnection, adOpenForwardOnly, adLockReadOnly
    BBS.AddQuery(SQL)

    ' Get into position
    if not(rsMaster.EOF) then rsMaster.move (iBookMark -1)

    if rsMaster.EOF then
      iUpperBound = -1
    else
      vThreadRows = rsMaster.GetRows(dictConfiguration("iFORUMTHREADPAGESIZE"))
      iUpperBound = UBOUND(vThreadRows, 2)
    end if
    rsMaster.Close

    stDisplayInfo = Forum.GetThreadInfoStruct()
    sBBSFragmentOutput = ""


    for index=0 to iUpperBound
      stDisplayInfo(TI_ThreadID) = vThreadRows(0, index)

      if vThreadRows(1, index) = 1 and bHasSticky = False then
        bHasSTicky = True
        vbForums.Append "<fieldset><legend class='error'>" & dictLanguage("GLOBAL-ANNOUNCEMENTS") & "</legend>"
      end if

      if vThreadRows(1, index) = 0 and bHasSticky = True then
        bHasSticky = False
        vbForums.Append "</fieldset>"
      end if

      vbForums.Append Forum.GenerateThreadedThread(vForumInfo, stDisplayInfo, vUserInfo, -1)



    next
    dictEnvironment.add "V-THREADEDLIST", vbForums.ToString()
    sBBSFragmentOutput = ""

    Filesystem.ExecuteFragmentTemplate("/forum-view-threaded-body.asp")
    dictEnvironment.add "V-THREADEDBODY", sBBSFragmentOutput
    sBBSFragmentOutput = ""

  end if

%>

<!-- #include file="../includes/header.asp" -->
<% Filesystem.ExecuteBBSTemplate("/forum/forum-view.asp") %><!-- #include file="../includes/footer.asp" -->